// Generated by CoffeeScript 1.8.0
(function() {
  var $, Opts, Rabbit, log;

  $ = require("bling");

  Rabbit = require('rabbit.js');

  Opts = require('./opts');

  log = $.logger("[rabbit]");

  $.extend(module.exports, {
    connect: function(url) {
      var context, patterns, ready, sockets;
      log("Connecting to...", url);
      ready = $.Promise();
      sockets = Object.create(null);
      patterns = Object.create(null);
      context = Rabbit.createContext(url);
      context.on("ready", function() {
        log("Connected.");
        return ready.resolve(context);
      });
      context.on("error", function(err) {
        log("Failed to connect to", url, err);
        return ready.reject(err);
      });
      $.subscribe("amqp-route", function(channel, pattern, handler) {
        return ready.wait(function(err, context) {
          var obj, onData, sub;
          if (Opts.verbose) {
            log("adding route:", channel, $.toRepr(pattern));
          }
          if (err != null) {
            return log("error:", err);
          }
          sub = sockets[channel];
          obj = {
            pattern: pattern,
            handler: handler
          };
          onData = null;
          if (sub != null) {
            return patterns[channel].push(obj);
          } else {
            patterns[channel] = [obj];
            sockets[channel] = sub = context.socket('SUB');
            sub.on('data', onData = function(data) {
              var list, _i, _len, _results;
              try {
                data = JSON.parse(String(data));
              } catch (_error) {
                err = _error;
                return log("JSON.parse error:", err.message, "in", String(data));
              }
              list = patterns[channel];
              _results = [];
              for (_i = 0, _len = list.length; _i < _len; _i++) {
                obj = list[_i];
                if ($.matches(obj.pattern, data)) {
                  try {
                    _results.push(obj.handler(data));
                  } catch (_error) {
                    err = _error;
                    _results.push(log("error in handler:", err.stack));
                  }
                }
              }
              return _results;
            });
            sub.on('drain', onData);
            return sub.connect(channel, function() {
              return log("connected to channel", channel);
            });
          }
        });
      });
      return ready;
    }
  });

}).call(this);
